stages:
  - build
  - deploy

include:
  - '/ci/build/build-webapp.gitlab-ci.yml'
  - '/ci/pages/deploy-webapp.gitlab-ci.yml'

# -----------------------------
# Buid the web-app
# -----------------------------
build-index:
  stage: build
  # => define the build process (👀 /ci/build/build-webapp.gitlab-ci.yml)
  extends: .build-webapp
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID

# -----------------------------
# Deploy the web-app
# -----------------------------
pages:
  stage: deploy
  # => define the deployment process (👀 /ci/pages/deploy-webapp.gitlab-ci.yml)
  extends: .deploy-webapp
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  environment:
    name: ${CI_PROJECT_NAME}-${CI_COMMIT_REF_NAME}
    url: $DYNAMIC_ENVIRONMENT_URL
    on_stop: remove-environment

# -----------------------------
# Undeploy the web-app
# -----------------------------
remove-environment:
  stage: deploy
  rules:
    - if: $CI_MERGE_REQUEST_IID
      when: manual
    - if: $CI_COMMIT_BRANCH == "main"
      when: never
  environment:
    name: ${CI_PROJECT_NAME}-${CI_COMMIT_REF_NAME}
    action: stop
  allow_failure: true
  script:
    - echo "web application deleted"
